# A clock made out of 2 stepper motors

This clock is made out of 2 nema 17 stepper motors. The motors are most definitely overkill, but its easy to build and this way you can control both clock-hands (? ... called Uhrzeiger in german ;) ).


Controller is a ESP32 (NodeMCU 32S) programmed with micropython. The time source is a DS3231 as the clock should work without a network connection (so no NTP sync for now).

## Pinout

Pin (ESP32)| Function
--- | ---
17 | i2c SDA (DS3231)
18 | i2c SCL (DS3231)
12,27,26,25 | Stepper for hour
19,21,22,23 | Stepper for minute
15 | capacitive touch button
36,39,34 | Button-Input
32,33,13 | Button-LEDs
16 | Housing-LEDs
2 | Piezo-Buzzer
4,5 | Free GPIO
35 | Free GPInput

## Reference

[L298M H-Bridge](https://www.instructables.com/id/Control-DC-and-stepper-motors-with-L298N-Dual-Moto/)

[DS3231 RTC](https://github.com/micropython-Chinese-Community/mpy-lib/tree/master/misc/DS3231)

[NodeMCU-32S Pinout](https://www.shenzhen2u.com/NodeMCU-32S)

[ESP32 Usable Pins](https://randomnerdtutorials.com/esp32-pinout-reference-gpios/)
